﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Private mWS As WebSocket
	
End Sub

Public Sub Initialize(WS As WebSocket)
	
	mWS = WS

End Sub

' ClientInformations

Sub GetClientHeight() As Future
	Return mWS.EvalWithResult("return $(window).height()", Null)
End Sub
Sub GetClientWidth() As Future
	Return mWS.EvalWithResult("return $(window).width()", Null)
End Sub

' Load JS and CSS

Sub LoadJsFile(Filename As String, Callback As String)
	mWS.Eval("checkloadjscssfile(arguments[0], 'js', arguments[1])", Array As Object(Filename, Callback))
End Sub
Sub LoadCssFile(Filename As String)
	mWS.Eval("checkloadjscssfile(arguments[0], 'css')", Array As Object(Filename))
End Sub

' LocalStorage

Sub LocalStorage_Available() As Future
	Return mWS.EvalWithResult("return $.jStorage.storageAvailable();", Null)
End Sub
Sub LocalStorage_GetItem(Key As String, Default As Object) As Future
	Return mWS.EvalWithResult("return $.jStorage.get(arguments[0], arguments[1]);", Array As Object(Key, Default))
End Sub
Sub LocalStorage_SetItem(Key As String, Value As Object)
	mWS.Eval("$.jStorage.set(arguments[0], arguments[1]);", Array As Object(Key, Value))
End Sub
Sub LocalStorage_RemoveItem(Key As String) 
	mWS.Eval("$.jStorage.deleteKey(arguments[0]);", Array As Object(Key))
End Sub
Sub LocalStorage_GetTTL(Key As String) As Future
	Return mWS.EvalWithResult("return $.jStorage.getTTL(arguments[0]);", Array As Object(Key))
End Sub
Sub LocalStorage_SetTTL(Key As String, TTL As Int)
	mWS.Eval("$.jStorage.setTTL(arguments[0], arguments[1]);", Array As Object(Key, TTL))
End Sub
Sub LocalStorage_ListenKeyChange(Key As String, Callback As Object)
	' mWS.Eval("$.jStorage.listenKeyChange(arguments[0], arguments[1]);", Array As Object(Key, Callback))
End Sub
Sub LocalStorage_StopListening(Key As String)
	mWS.Eval("$.jStorage.stopListening(arguments[0]);", Array As Object(Key))
End Sub
Sub LocalStorage_Clear() 
	mWS.Eval("$.jStorage.flush();", Null)
End Sub

