﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'WebSocket class

Sub Class_Globals

	Private WS As WebSocket
	
	Dim cmdOpenDialog As UIButton

	Dim myDialog As UIDialog
	
	Dim lblTheme As UILabel
	Dim cboTheme As UICombobox
	
	Dim lblMode As UILabel
	Dim cboMode As UICombobox
	
	Dim AceEditor As UIAceEditor
		
End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected(WebSocket1 As WebSocket)

	WS = WebSocket1

	OpenDialog

End Sub

Private Sub OpenDialog()
	
	myDialog.Initialize(WS, "myDialog", True)
	myDialog.SetWidth(600)
	myDialog.SetHeight(500)
	myDialog.SetTitle("Ace-Editor")
	myDialog.SetResizable(False)
	myDialog.Open
	
	' ######################

	lblTheme.Initialize(WS, "lblTheme")
	lblTheme.SetTop(13)
	lblTheme.SetLeft(10)
	lblTheme.SetWidth(50)
	lblTheme.SetText("Theme:")
	lblTheme.AppendTo("myDialog")

	cboTheme.Initialize(WS, "cboTheme")
	cboTheme.SetTop(10)
	cboTheme.SetLeft(60)
	cboTheme.SetWidth(180)
	
	Dim ListOfThemes As List
	ListOfThemes.Initialize()
	ListOfThemes.AddAll(Array As String("ambiance", "chaos", "chrome", "clouds", "clouds_midnight", _
	                                    "cobalt", "crimson_editor", "dawn", "dreamweaver", "eclipse", _
																			"github", "idle_fingers", "katzenmilch", "kr", "kuroir", _
																			"merbivore", "merbivore_soft", "mono_industrial", "monokai", _
																			"pastel_on_dark", "solarized_dark", "solarized_light", "terminal", _
																			"textmate", "tomorrow", "tomorrow_night", "tomorrow_night_blue", _
																			"tomorrow_night_bright", "tomorrow_night_eighties", "twilight", _
																			"vibrant_ink", "xcode"))
	
	Dim Counter As Int 
	
	For Counter = 0 To ListOfThemes.Size - 1
		cboTheme.AddItem(ListOfThemes.Get(Counter))
	Next

	cboTheme.SetTooltip("Select a theme...")
	cboTheme.SetText("eclipse")
	cboTheme.AppendTo("myDialog")
	
	' ######################
	
	lblMode.Initialize(WS, "lblMode")
	lblMode.SetTop(13)
	lblMode.SetLeft(260)
	lblMode.SetWidth(50)
	lblMode.SetText("Mode:")
	lblMode.AppendTo("myDialog")
	
	cboMode.Initialize(WS, "cboMode")
	cboMode.SetTop(10)
	cboMode.SetLeft(300)
	cboMode.SetWidth(180)
	
	Dim ListOfModes As List
	ListOfModes.Initialize()
	
	ListOfModes.AddAll(Array As String("abap", "actionscript", "ada", "apache_conf", "asciidoc", "assembly_x86", _
																		 "autohotkey", "batchfile", "c9search", "c_cpp", "cirru", "clojure", "cobol", _
																		 "coffee", "coldfusion", "csharp", "css", "curly", "d", "dart", "diff", _
																		 "django", "dot", "ejs", "erlang", "forth", "ftl", "gherkin", "glsl", "golang", _
																		 "groovy", "haml", "handlebars", "haskell", "haxe", "html", "html_completions", _
																		 "html_ruby", "ini", "jack", "jade", "java", "javascript", "json", "jsoniq", _
																		 "jsp", "jsx", "julia", "latex", "less", "liquid", "lisp", "livescript", _
																		 "logiql", "lsl", "lua", "luapage", "lucene", "makefile", "markdown", "matlab", _
																		 "mel", "mushcode", "mushcode_high_rules", "mysql", "nix", "objectivec", _
																		 "ocaml", "pascal", "perl", "pgsql", "php", "plain_text", "powershell", _
																		 "prolog", "properties", "protobuf", "python", "r", "rdoc", "rhtml", "ruby", _
																		 "rust", "sass", "scad", "scala", "scheme", "scss", "sh", "sjs", "smarty", _
																		 "snippets", "soy_template", "space", "sql", "stylus", "svg", "tcl", "tex", _
																		 "text", "textile", "tmsnippet", "toml", "twig", "typescript", "vbscript", _
																		 "velocity", "verilog", "vhdl", "xml", "xquery", "yaml"))
	
	For Counter = 0 To ListOfModes.Size - 1
		cboMode.AddItem(ListOfModes.Get(Counter))
	Next

	cboMode.SetTooltip("Select a mode...")
	cboMode.SetText("javascript")
	cboMode.AppendTo("myDialog")
	
	' ######################

	AceEditor.Initialize(WS, "AceEditor")
	
	AceEditor.SetTop(40)
	AceEditor.SetLeft(10)
	AceEditor.SetWidth(580)
	AceEditor.SetHeight(410)
	
	AceEditor.SetTheme("eclipse")
	AceEditor.SetMode("javascript")
	AceEditor.SetValue("huhu!")
	
	AceEditor.AppendTo("myDialog")

	AceEditor.SetValue(GetTestSource)
	
	AceEditor.SetFocus()

End Sub

Private Sub GetTestSource() As String
  
  Dim ReturnValue As StringBuilder
	
	ReturnValue.Initialize
  
  ReturnValue.Append("function ValidFunction() {").Append(CRLF)
  ReturnValue.Append(CRLF)
  ReturnValue.Append("}").Append(CRLF)
  ReturnValue.Append(CRLF)
  ReturnValue.Append("function InvalidFunction( {").Append(CRLF)
  ReturnValue.Append(CRLF)
  ReturnValue.Append("}").Append(CRLF)
  
  Return ReturnValue.ToString
  
End Sub

Private Sub cboTheme_Change(Params As Map)

	Dim SelectedTheme As String 
	SelectedTheme = cboTheme.GetText().Value
	AceEditor.SetTheme(SelectedTheme)

End Sub

Private Sub cboMode_Change(Params As Map)

	Dim SelectedMode As String 
	SelectedMode = cboMode.GetText().Value
	AceEditor.SetMode(SelectedMode)

End Sub

Private Sub myDialog_Close(Params As Map)

	cmdOpenDialog.Initialize(WS, "cmdOpenDialog")
	cmdOpenDialog.SetText("Open dialog")

End Sub

Private Sub cmdOpenDialog_Click(Params As Map)

	cmdOpenDialog.Remove

	OpenDialog
	
End Sub

Private Sub WebSocket_Disconnected

End Sub