﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'WebSocket class

Sub Class_Globals

	Private WS As WebSocket
	
	Dim cmdOpenHelloWorldDialog As UIButton
	Dim cmdOpenLoginDialog As UIButton
	Dim cmdOpenInputTestDialog As UIButton

	Dim dlgHelloWorld As UIDialog
	Dim cmdHelloWorld As UIButton
		
	Dim dlgLogin As UIDialog
	Dim lblUsername As UILabel
	Dim txtUsername As UIInput
	Dim lblPassword As UILabel
	Dim txtPassword As UIInput
	Dim cmdOK As UIButton
	Dim cmdCancel As UIButton
	
	Dim dlgTest As UIDialog

End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected(WebSocket1 As WebSocket)

	WS = WebSocket1
	
	cmdOpenHelloWorldDialog.Initialize(WS, "cmdOpenHelloWorldDialog")
	cmdOpenHelloWorldDialog.SetText("Open HelloWorld-Dialog")
	cmdOpenHelloWorldDialog.Resize(10, 10, 200, 30)
	cmdOpenHelloWorldDialog.SetTop(10)
	cmdOpenHelloWorldDialog.SetWidth(200)
	cmdOpenHelloWorldDialog.SetHeight(30)
	
	cmdOpenLoginDialog.Initialize(WS, "cmdOpenLoginDialog")
	cmdOpenLoginDialog.SetText("Open Login-Dialog")
	cmdOpenLoginDialog.SetLeft(10)
	cmdOpenLoginDialog.SetTop(50)
	cmdOpenLoginDialog.SetWidth(200)
	cmdOpenLoginDialog.SetHeight(30)
	
	cmdOpenInputTestDialog.Initialize(WS, "cmdOpenInputTestDialog")
	cmdOpenInputTestDialog.SetText("Open InputTest-Dialog")
	cmdOpenInputTestDialog.SetLeft(10)
	cmdOpenInputTestDialog.SetTop(90)
	cmdOpenInputTestDialog.SetWidth(200)
	cmdOpenInputTestDialog.SetHeight(30)
	
End Sub

Private Sub cmdOpenHelloWorldDialog_Click(Params As Map)
	OpenHelloWorldDialog
End Sub

Private Sub cmdOpenLoginDialog_Click(Params As Map)
	OpenLoginDialog
End Sub

Private Sub cmdOpenInputTestDialog_Click(Params As Map)
	OpenInputTestDialog
End Sub

Private Sub OpenHelloWorldDialog()

	dlgHelloWorld.Initialize(WS, "dlgHelloWorld", True) ' Create a modal dialog
	dlgHelloWorld.Resize(-1, -1, 800, 500)
	dlgHelloWorld.SetTitle("HelloWorld")
	dlgHelloWorld.Open
	
End Sub

Private Sub cmdHelloWorld_Click(Params As Map)
End Sub

Private Sub OpenLoginDialog()

	' ########################

	dlgLogin.Initialize(WS, "dlgLogin", True) ' Create a modal dialog
	dlgLogin.SetTitle("Login")
	dlgLogin.SetWidth(325)
	dlgLogin.SetClosable(False)
	dlgLogin.SetResizable(False)
	dlgLogin.Open
	
	' ########################

	lblUsername.Initialize(WS, "lblUsername")
	lblUsername.SetTop(15)
	lblUsername.SetLeft(10)
	lblUsername.SetText("Username:")
	lblUsername.AppendTo("dlgLogin")
	
	txtUsername.Initialize(WS, "txtUsername", "") ' 3rd parameter is for the type. Leave it empty for 'normal' text
	txtUsername.SetTop(10)
	txtUsername.SetLeft(90)
	txtUsername.SetWidth(215)
	txtUsername.SetPlaceholder("Username")
	txtUsername.AppendTo("dlgLogin")
	
	' ####
	
	lblPassword.Initialize(WS, "lblPassword")
	lblPassword.SetTop(45)
	lblPassword.SetLeft(10)
	lblPassword.SetText("Password:")
	lblPassword.AppendTo("dlgLogin")

	txtPassword.Initialize(WS, "txtPassword", "password")
	txtPassword.SetTop(40)
	txtPassword.SetLeft(90)
	txtPassword.SetWidth(215)
	txtPassword.AppendTo("dlgLogin")

	' ########################
	
	cmdOK.Initialize(WS, "cmdOK")
	cmdOK.SetText("OK")
	cmdOK.SetLeft(100)
	cmdOK.SetTop(80)
	cmdOK.SetWidth(100)
	cmdOK.SetHeight(30)
	cmdOK.AppendTo("dlgLogin")
	
	' #######
	
	cmdCancel.Initialize(WS, "cmdCancel")
	cmdCancel.SetText("Cancel")
	cmdCancel.SetLeft(210)
	cmdCancel.SetTop(80)
	cmdCancel.SetWidth(100)
	cmdCancel.SetHeight(30)
	cmdCancel.AppendTo("dlgLogin")
	
	CheckOkButton
	
End Sub

Private Sub dlgLogin_Close(Params As Map)
	WS.Alert("Dialog is closed")
End Sub

Private Sub cmdOK_Click(Params As Map)
	WS.Alert("Welcome, " & txtUsername.GetText.Value)
End Sub

Private Sub cmdCancel_Click(Params As Map)
	dlgLogin.Close
End Sub

Private Sub txtUsername_KeyUp(Params As Map)

	CheckOkButton

End Sub

Private Sub txtPassword_KeyUp(Params As Map)

	CheckOkButton

End Sub

Private Sub CheckOkButton()

	Dim Username As Future = txtUsername.GetText
	Dim Password As Future = txtPassword.GetText

	If Username.Value = "" OR Password.Value = "" Then
		cmdOK.SetDisabled(True)
	Else
		cmdOK.SetDisabled(False)
	End If
	
End Sub

Private Sub OpenInputTestDialog()

	Dim InputTypes As List
	InputTypes.Initialize
	InputTypes.AddAll(Array As String("password", "color", "date", "datetime", "datetime-local", "email", _
																		"month", "number", "range", "search", "tel", "time", "url", "week"))

	dlgTest.Initialize(WS, "dlgTest", True)
	dlgTest.SetTitle("Test")
	dlgTest.SetWidth(420)
	dlgTest.SetHeight(500)
	dlgTest.SetResizable(False)

	Dim Counter As Int 
	
	For Counter = 0 To InputTypes.Size - 1

		Dim lblInput As UILabel

		lblInput.Initialize(WS, "lblInput" & Counter)
		lblInput.SetText(InputTypes.Get(Counter) & ":")
		lblInput.SetTop(((Counter + 1) * 30) + 5)
		lblInput.SetWidth(100)
		lblInput.AppendTo("dlgTest")

	
		Dim txtInput As UIInput

		txtInput.Initialize(WS, "txtInput" & Counter, InputTypes.Get(Counter))
		txtInput.SetLeft(120)
		txtInput.SetTop((Counter + 1) * 30)
		txtInput.SetWidth(200)
		txtInput.AppendTo("dlgTest")
	
	Next
	
	dlgTest.Open

End Sub

Private Sub WebSocket_Disconnected

End Sub