﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'WebSocket class

Sub Class_Globals

	Private WS As WebSocket

	Dim GoogleMap As UIGoogleMap
	
	Dim lblAddress As UILabel
	Dim txtAddress As UITextArea

	Dim cmdRequestLatLng As UIButton

	Dim lblNote As UILabel
	Dim lblLat As UILabel
	Dim lblLng As UILabel

	Dim RequestLatLng As JQueryElement
	
End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected(WebSocket1 As WebSocket)

	WS = WebSocket1
	
	' ##################

	GoogleMap.Initialize(WS, "GoogleMap")
	GoogleMap.Resize(10, 10, 600, 400)

	GoogleMap.AddEvent("RequestLatLng_Success", True)
	GoogleMap.AddEvent("RequestLatLng_Error", True)

	
	' ##################

	lblAddress.Initialize(WS, "lblAddress")
	lblAddress.Resize(620, 10, -1, -1)
	lblAddress.SetText("Address:")

	' ##################

	txtAddress.Initialize(WS, "txtAddress")
	txtAddress.Resize(620, 30, 200, 100)
	txtAddress.SetText("Eiffel Tower" & Chr(13) & Chr(10) & "Paris")

	' ##################
	
	cmdRequestLatLng.Initialize(WS, "cmdRequestLatLng")
	cmdRequestLatLng.Resize(620, 140, 200, -1)
	cmdRequestLatLng.SetText("Set marker on map")

	' ##################

	lblNote.Initialize(WS, "lblNote")
	lblNote.Resize(620, 190, -1, -1)

	' ##################

	lblLat.Initialize(WS, "lblLat")
	lblLat.Resize(620, 220, -1, -1)

	' ##################

	lblLng.Initialize(WS, "lblLng")
	lblLng.Resize(620, 240, -1, -1)

End Sub

Private Sub cmdRequestLatLng_Click(Params As Map)
	
	lblNote.SetText("")
	lblLat.SetText("Lat: ---")
	lblLng.SetText("Lng: ---")

	GoogleMap.RequestLatLng(txtAddress.GetText.Value)

End Sub

Private Sub RequestLatLng_OnSuccess(Params As Map)
		
	Dim result As String = 	Params.Get("result")
	
	Dim Line() As String = Regex.Split(CRLF, result)

	If Line.Length > 1 Then
		lblNote.SetText("Note: Found " & Line.Length & " locations. Using the first one.")
	End If

	Dim resultpart() As String = Regex.Split(";", Line(0))

	txtAddress.SetText(resultpart(0))

	resultpart(1) = resultpart(1).Replace("(", "")
	resultpart(1) = resultpart(1).Replace(")", "")
	
	Dim latlng() As String = Regex.Split(",", resultpart(1))
	
	lblLat.SetText("Lat: " & latlng(0))
	lblLng.SetText("Lng: " & latlng(1))
	
	GoogleMap.RemoveMarker(0)
	
	GoogleMap.AddMarker(0, latlng(0), latlng(1))
	
	GoogleMap.SetCenterAtMarker(0)
	
	GoogleMap.SetZoom(16)
	
	GoogleMap.SetMarkerInfoWindow(0, resultpart(0), True)

End Sub

Private Sub RequestLatLng_OnError(Params As Map)

	Dim Result As String 
	Result = Params.Get("result")	
	WS.Alert(Result)

End Sub

Private Sub WebSocket_Disconnected

End Sub