﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'WebSocket class
Sub Class_Globals

	Private WS As WebSocket
	Private WC As cWebClient
	
	Private lblMousePosition As UILabel
	Private lblClientSize As UILabel

	Private Image As UIImage
	Private Listbox As UIListbox
	Private cmdClearItems As UIButton
	
	Private Fieldset4Checkboxes As UIHtmlElement
	Private Checkbox1 As UICheckbox
	Private Checkbox2 As UICheckbox
	Private Checkbox3 As UICheckbox

	Private Fieldset4Radiobuttons As UIHtmlElement
	Private Radiobutton1 As UIRadiobutton
	Private Radiobutton2 As UIRadiobutton
	Private Radiobutton3 As UIRadiobutton

	Private Progressbar As UIProgressbar
	
	Private Slider As UISlider
	Private RangeSlider As UISlider

	Private myTimer As Timer

End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected(WebSocket1 As WebSocket)

	WS = WebSocket1
	
	
	WS.Eval( _
	"$(document).on('mousemove', function(e){" & _
	"b4j_ws.send(JSON.stringify({type: 'event', event: 'client_mousemove', params: { posX: e.pageX, posY: e.pageY } })); " & _
	"});", Null)

	WS.Eval( _ 
	"$(window).on('resize', function(e){" & _
	"b4j_ws.send(JSON.stringify({type: 'event', event: 'client_resize', params: { width: $(window).width(), height: $(window).height() } })); " & _
	"});", Null)

	WC.Initialize(WS)

	lblMousePosition.Initialize(WS, "lblMousePosition")
	lblMousePosition.Resize(10, 10, 300, 30)
	lblMousePosition.SetText("MouseX: --- / MouseY: ---")

	lblClientSize.Initialize(WS, "lblClientSize")
	lblClientSize.Resize(10, 40, 300, 30)
	lblClientSize.SetText("ClientHeight: " & WC.GetClientHeight.Value & " / ClientWidth: " & WC.GetClientWidth.Value)

	' Image

	Image.Initialize(WS, "myImage")
	
	Image.AddEvent("load", True)       ' -> Sub myImage_Load
	Image.AddEvent("click", True)      ' -> Sub myImage_Click
	Image.AddEvent("mouseenter", True) ' -> Sub myImage_MouseEnter
	Image.AddEvent("mouseleave", True) ' -> Sub myImage_MouseLeave
	Image.AddEvent("error", True)      ' -> Sub myImage_Error
	
	Image.Resize(10, 70, -1, -1)
	Image.SetCss("border", "1px solid black")
	Image.SetImage("http://abload.de/img/funny-dog-loversfuawt.png")
	Image.SetAlt("Flowerdog")
	Image.SetTooltip("sooo cute!")

	' Listbox
	
	Listbox.Initialize(WS, "Listbox")
	Listbox.Resize(460, 10, 400, 300)
	
	cmdClearItems.Initialize(WS, "cmdClearItems")
	cmdClearItems.SetText("Clear items")
	cmdClearItems.Resize(460, 315, 200, -1)

	' Checkboxes
		
	Fieldset4Checkboxes.Initialize(WS, "Fieldset4Checkboxes", "fieldset")
	Fieldset4Checkboxes.Resize(10, 420, 100, 80)
	Fieldset4Checkboxes.AppendHtml("<legend>Checkboxes</legend>")
	
	Checkbox1.Initialize(WS, "Checkbox1")
	Checkbox1.SetEventObjectName("CB", "click", False)
	Checkbox1.Resize(-1, 20, -1, -1)
	Checkbox1.SetText("Checkbox1")
	Checkbox1.SetChecked(True)
	Checkbox1.AppendTo("Fieldset4Checkboxes")
		
	Checkbox2.Initialize(WS, "Checkbox2")
	Checkbox2.SetEventObjectName("CB", "click", False)
	Checkbox2.Resize(-1, 40, -1, -1)
	Checkbox2.SetText("Checkbox2")
	Checkbox2.SetChecked(False)
	Checkbox2.AppendTo("Fieldset4Checkboxes")

	Checkbox3.Initialize(WS, "Checkbox3")
	Checkbox3.SetEventObjectName("CB", "click", False)
	Checkbox3.Resize(-1, 60, -1, -1)
	Checkbox3.SetText("Checkbox3")
	Checkbox3.SetChecked(True)
	Checkbox3.AppendTo("Fieldset4Checkboxes")

	' Radiobuttons
	
	Fieldset4Radiobuttons.Initialize(WS, "Fieldset4Radiobuttons", "fieldset")
	Fieldset4Radiobuttons.Resize(150, 420, 150, 80)
	Fieldset4Radiobuttons.AppendHtml("<legend>Radiobuttons</legend>")

	Radiobutton1.Initialize(WS, "Radiobutton1", "RadiobuttonGroup")
	Radiobutton1.SetEventObjectName("RB", "click", False)
	Radiobutton1.Resize(-1, 20, -1, -1)
	Radiobutton1.SetText("Radiobutton1")
	Radiobutton1.SetChecked(True)
	Radiobutton1.AppendTo("Fieldset4Radiobuttons")
		
	Radiobutton2.Initialize(WS, "Radiobutton2", "RadiobuttonGroup")
	Radiobutton2.SetEventObjectName("RB", "click", False)
	Radiobutton2.Resize(-1, 40, -1, -1)
	Radiobutton2.SetText("Radiobutton2")
	Radiobutton2.AppendTo("Fieldset4Radiobuttons")
		
	Radiobutton3.Initialize(WS, "Radiobutton3", "RadiobuttonGroup")
	Radiobutton3.SetEventObjectName("RB", "click", False)
	Radiobutton3.Resize(-1, 60, -1, -1)
	Radiobutton3.SetText("Radiobutton3")
	Radiobutton3.AppendTo("Fieldset4Radiobuttons")
	
	' Progressbar
	
	Progressbar.Initialize(WS, "Progressbar")
	Progressbar.Resize(460, 400, 200, -1)
	Progressbar.SetValue(50)
	
	' Slider
	
	Slider.Initialize(WS, "Slider")
	Slider.SetMin(0)
	Slider.SetMax(100)
	Slider.SetValue(50)
	Slider.Resize(460, 450, 200, -1)

	RangeSlider.Initialize(WS, "RangeSlider")
	RangeSlider.SetMin(0)
	RangeSlider.SetMax(100)
	RangeSlider.SetRange(True)
	
	Dim Ranges As List
	Ranges.Initialize2(Array As Int(20, 80))
	
	RangeSlider.SetValues(Ranges)
	RangeSlider.Resize(460, 480, 200, -1)

	myTimer.Initialize("myTimer", 5000)
	myTimer.Enabled = True

End Sub

Private Sub myTimer_Tick
	
	Listbox.AddItem("TimerTick: " & DateTime.Time(DateTime.Now) , -1, True)
	WS.Flush
	
End Sub

Private Sub Client_Resize(Params As Map)

	Dim Width As Int
	Dim Height As Int
	
	Width = Params.Get("width")
	Height = Params.Get("height")

	lblClientSize.SetText("ClientHeight: " & Height & " / ClientWidth: " & Width)
	
End Sub

Private Sub Client_MouseMove(Params As Map)

	Dim posY As Int
	Dim posX As Int
	
	posY = Params.Get("posY")
	posX = Params.Get("posX")

	lblMousePosition.SetText("MouseX: " & posX & " / MouseY: " & posY)

End Sub

Private Sub Bla()

'	TXT.Initialize(WS, "TXT")
'	TXT.SetTop(100)
'	TXT.SetWidth(600)
'	TXT.SetHeight(400)
'	
'	IMG.Initialize(WS, "IMG")

'	Dim I As InputStream = File.OpenInput("C:\Users\Pitta\Dropbox\code\B4J\WebApp\Objects\www", "wait.gif")
'	Dim buffer(I.BytesAvailable) As Byte
'	I.ReadBytes(buffer, 0, buffer.Length)
'	I.Close
'	
'	Dim SU As StringUtils
'	
'	Dim b64 As String = SU.EncodeBase64(buffer)
'	
'	TXT.SetText(b64)
'
'	IMG.SetImage("data:image/gif;base64," & b64)
'
'	Return

End Sub

' Radiobutton

Private Sub RB_Click(Params As Map)

	Listbox.AddItem("Radiobutton1: " & Radiobutton1.GetChecked.Value, -1, True)
	Listbox.AddItem("Radiobutton2: " & Radiobutton2.GetChecked.Value, -1, True)
	Listbox.AddItem("Radiobutton3: " & Radiobutton3.GetChecked.Value, -1, True)
	
End Sub

' Checkbutton

Private Sub CB_Click(Params As Map)
	Listbox.AddItem("Checkbox1: " & Checkbox1.GetChecked.Value, -1, True)
	Listbox.AddItem("Checkbox2: " & Checkbox2.GetChecked.Value, -1, True)
	Listbox.AddItem("Checkbox3: " & Checkbox3.GetChecked.Value, -1, True)
End Sub

Private Sub cmdClearItems_Click(Params As Map)
	Listbox.ClearItems()
End Sub

' myImage-Events

Private Sub myImage_Load(Params As Map)
	Listbox.AddItem("Image: Loaded", -1, True)
End Sub

Private Sub myImage_Click(Params As Map)
	Listbox.AddItem("Image: Click", -1, True)
End Sub

Private Sub myImage_MouseEnter(Params As Map)
	Listbox.AddItem("Image: MouseEnter", -1, True)
End Sub

Private Sub myImage_MouseLeave(Params As Map)
	Listbox.AddItem("Image: MouseLeave", -1, True)
End Sub

Private Sub myImage_Error(Params As Map)
	Listbox.AddItem("Image: Error", -1, True)
End Sub

' Slider-Events:

Private Sub Slider_Change(Params As Map)
	Listbox.AddItem("Slider (Change-Event): Value = " & Slider.GetValue.Value, -1, True)
End Sub

Private Sub Slider_Start(Params As Map)
	Listbox.AddItem("Slider (Start-Event): Value = " & Slider.GetValue.Value, -1, True)
End Sub

Private Sub Slider_Stop(Params As Map)
	Listbox.AddItem("Slider (Stop-Event): Value = " & Slider.GetValue.Value, -1, True)
End Sub

Private Sub Slider_Slide(Params As Map)
	Listbox.AddItem("Slider: Slide-Event", -1, True)
End Sub

' RangeSlider:

Private Sub RangeSlider_Change(Params As Map)
	Listbox.AddItem("RangeSlider (Change-Event): Value = " & RangeSlider.GetValues.Value, -1, True)
End Sub

' ##################

Private Sub WebSocket_Disconnected

End Sub