﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'WebSocket class
Sub Class_Globals

	Private WS As WebSocket
	
	Private Grid As UIw2uiGrid
	
	Private cmdPopulate As UIButton
	Private cmdGetRecords As UIButton
	Private cmdLock As UIButton
	Private cmdUnlock As UIButton
	Private cmdGetChanges As UIButton
	
	Private txtLog As UITextArea
	
End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)

	WS = WebSocket1

	Grid.Initialize(WS, "Grid")
	Grid.Resize(10, 50, 610, 480)
	Grid.SetToolbarVisible(True)
	Grid.SetFooterVisible(True)
	Grid.Refresh
	
	cmdPopulate.Initialize(WS, "cmdPopulate")
	cmdPopulate.SetCss("position", "")
	cmdPopulate.SetText("Populate with data")
	
	cmdLock.Initialize(WS, "cmdLock")
	cmdLock.SetCss("position", "")
	cmdLock.SetText("Lock")
	
	cmdUnlock.Initialize(WS, "cmdUnlock")
	cmdUnlock.SetCss("position", "")
	cmdUnlock.SetText("Unlock")
	cmdUnlock.SetDisabled(True)

	cmdGetRecords.Initialize(WS, "cmdGetRecords")
	cmdGetRecords.SetCss("position", "")
	cmdGetRecords.SetText("Get records")

	cmdGetChanges.Initialize(WS, "cmdGetChanges")
	cmdGetChanges.SetCss("position", "")
	cmdGetChanges.SetText("Get changes")

	txtLog.Initialize(WS, "txtLog")
	txtLog.Resize(630, 10, 300, 510)
		

	
End Sub

Private Sub PopulateGrid()

 ' ##################
	
	' set columns
	
	Grid.Lock("Populating data...", True)
	
	WS.Flush
	
	Dim ColumnEditType As Map = CreateMap("type": "text")
	
	Dim ColumnList As List
	ColumnList.Initialize

	Dim Column As Map

	For Counter = 1 To 3
	
		Column = CreateMap("field":     "column" & Counter, _
											 "caption":   "Column " & Counter, _
											 "size":      "100px", _
											 "sortable":  True, _
											 "resizable": True, _
											 "editable":  ColumnEditType)

		ColumnList.Add(Column)
		
	Next
	
	Grid.SetColumns(ColumnList)

  ' ##################

  ' set records

	Dim RecordList As List
	RecordList.Initialize
	
	Dim Record As Map
	Dim Row As Int
	
	For Row = 0 To 99
	
		Record = CreateMap("recid": Row, _
											 "column1": "value Row: " & (Row+1) & " Col: 1", _
											 "column2": "value Row: " & (Row+1) & " Col: 2", _
											 "column3": "value Row: " & (Row+1) & " Col: 3")
		
		RecordList.Add(Record)
	
	Next

	Grid.SetRecords(RecordList)
	
  ' ##################

	Dim SearchList As List
	SearchList.Initialize
	
	For Counter = 1 To 3
	
		Dim Search As Map
		Search.Initialize
		
		Search.Put("field", "column" & Counter)
		Search.Put("caption", "c" & Counter)
		Search.Put("type", "text")
	
		SearchList.Add(Search)
	
	Next
	
	Grid.SetSearch(SearchList)
	
	Grid.Refresh

	Grid.Unlock

End Sub

Private Sub cmdPopulate_Click(Params As Map)
	PopulateGrid
End Sub

Private Sub cmdLock_Click(Params As Map)
	Grid.Lock("Grid is locked!", True)
	cmdLock.SetDisabled(True)
	cmdUnlock.SetDisabled(False)
End Sub

Private Sub cmdUnlock_Click(Params As Map)
	Grid.Unlock()
	cmdLock.SetDisabled(False)
	cmdUnlock.SetDisabled(True)
End Sub

Private Sub cmdGetRecords_Click(Params As Map)
	
	' Please note, that GetRecords will fail, 
	' if the amount of data is > 64 KB
	
	Dim Records As Future
	Records = Grid.GetRecords
	
	Try
	
'		Dim List1 As List
'		List1.Initialize
'		List1.AddAll(Records.Value)

		txtLog.SetText(Records.Value)

	Catch
	
		WS.Alert("Error")
	
	End Try
	
End Sub

Private Sub cmdGetChanges_Click(Params As Map)

	Dim Changes As Future = Grid.GetChanges()
	
	Try
	
		Dim List1 As List
		List1.Initialize
		List1.AddAll(Changes.Value)

		txtLog.SetText(Changes.Value)

	Catch
	
		WS.Alert("Error")
	
	End Try
	

End Sub

Private Sub WebSocket_Disconnected

End Sub

